<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

   <v-container>

   <v-form
      ref="form" v-model="valid"
    >

    <MessageBox
      :model="message"
      v-on:hide="message.show=false"
    />


        <CommonHeader
          :title="MSG.PR_GENERAL_SECTION_TITLE"
          :description="MSG.PR_GENERAL_SECTION_DESCRIPTION"
        />

        <v-container>
          <v-row dense>
            <v-col cols="6" >
              <v-text-field
                label="Name"
                hint="The name of the provider"
                v-model="providerData.name"
                :rules="nameRules"
                counter="50"
                required
              ></v-text-field>
            </v-col>
            <v-col cols="6" >
              <v-text-field
                label="ID"
                hint="Unique id for this provider (not modifiable)"
                v-model="providerData.id"
                disabled
                readonly
              ></v-text-field>
            </v-col>
          </v-row>
          <v-row>
            <v-col cols="12">
              <v-text-field
                label="Description (optional)"
                hint="A description for this provider"
                v-model="providerData.description"
                :rules="descriptionRules"
                counter="200"
                ></v-text-field>
            </v-col>
          </v-row>
        </v-container>

        <CommonHeader
          :title="MSG.PR_CONNECTION_SECTION_TITLE"
          :description="MSG.PR_CONNECTION_SECTION_DESCRIPTION"
        />

        <Kubernetes
          v-if="providerData.driver=='kubernetes'"
          :provider="providerData"
          :providerTechnologies="providerTechnologies"
        />

        <OpenStack
          v-if="providerData.driver=='openstack'"
          :provider="providerData"
          :providerTechnologies="providerTechnologies"
        />
        <VMware
          v-if="providerData.driver=='vmware'"
          :provider="providerData"
          :providerTechnologies="providerTechnologies"
        />
        <EC2
          v-if="providerData.driver=='ec2'"
          :provider="providerData"
          :providerTechnologies="providerTechnologies"
        />

        <v-container>
          <v-row dense>
            <v-col cols="12">
              <v-btn
                :disabled="!valid"
                v-on:click="save(true, false)"
                small
              >Save & Test Connection</v-btn>
            </v-col>
          </v-row>
          <v-row dense>
            <v-col cols="12">
              <div style="border-radius:5px; background:lightgrey; padding:10px; color:white" v-if="this.testing">
                <v-icon color="white">mdi-cloud-outline</v-icon> Connecting...
              </div>
              <div class="success" style="border-radius:5px; padding:10px; color:white" v-if="this.testResult=='success'">
                <v-icon color="white">mdi-cloud-check</v-icon> Connection to the provider is working
              </div>
              <div class="error" style="border-radius:5px; padding:10px; color:white" v-if="this.testResult=='error'">
                <v-icon color="white">mdi-cloud-off-outline</v-icon> Connection to the provider failed
              </div>
            </v-col>
          </v-row>
        </v-container>


        <CommonHeader
          :subtitle="MSG.PR_CUSTOM_PROPS_SECTION_TITLE"
          :description="MSG.PR_CUSTOM_PROPS_SECTION_DESCRIPTION"
          :descriptionAsHint="false"
        />
        <KeyValues
          :entries="customProperties"
          :reservedKeys="reservedKeys()"
          keyHint="The name of the property"
          valueHint="The value of the property"
          invalidChars=" "
          addButtonLabel="Add custom property"
          :readonly="false"
        />

      <CommonHeader
        title="Service accounts"
        description="Default credentials (username/password) for the different VM images."
      />
      <KeyValues
        :entries="serviceProperties"
        keyHint="The name of the property"
        valueHint="The value of the property"
        invalidChars=" "
        addButtonLabel="Add service property"
        :readonly="false"
      />

      <CommonHeader
      :title="MSG.PR_POST_CREATE_SCRIPTS_SECTION_TITLE"
      :description="MSG.PR_POST_CREATE_SCRIPTS_SECTION_DESCRIPTION"
      />
      <KeyValues
        :entries="scripts"
        :reservedKeys="reservedKeysInPostCreateScripts"
        keyHint="The name of the script"
        valueHint="The value of the script"
        valueLabel="Commands"
        keyLabel="Script name"
        invalidChars=" "
        addButtonLabel="Add script"
        :readonly="false"
        :multilineValue="true"
      />

      <template v-if="false">

        <CommonHeader
          title="Sharing"
          description="Update who can see and use this provider."
        />

        <v-container>
          <v-radio-group v-model="sharing">
            <v-radio value="private"
              :label="MSG.PR_PRIVATE"
            >
            </v-radio>
            <v-radio value="public"
              :label="MSG.PR_PUBLIC"
            >
            </v-radio>
          </v-radio-group>
        </v-container>

      </template>

      <v-divider/>

      <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn @click="exit()">Back</v-btn>
          <v-btn
            v-if="providerData.id==null"
            color="primary"
            :disabled="!valid"
            v-on:click="save(false, true)"
          >Create & Exit</v-btn>
          <v-btn
            v-else
            color="primary"
            :disabled="!valid"
            v-on:click="save(false, true)"
          >Save & Exit</v-btn>
      </v-card-actions>

    </v-form>

  </v-container>

</template>

<script>

import CommonHeader from '../common/CommonHeader.vue';
import KeyValues from '../common/KeyValues.vue';
import MessageBox from '../common/MessageBox.vue';
import { MESSAGES } from "../common/messages";

import OpenStack from './editors/OpenStack.vue';
import VMware from './editors/VMware.vue';
import EC2 from './editors/EC2.vue';
import Kubernetes from './editors/Kubernetes.vue'

import _getKnownProperties from './providers.js';


import { getProviderSharingLevel, trimStringValues } from '../common/benchsuite.js';

export default {

  name: 'Provider',

  props: {
    providerId: {
      type: String,
      default: ''
    },
    templateProviderId: {
      type: String,
      default: ''
    },
    provider: {
      type: Object,
      default: function() {return {}}
    }
  },

  components: {
    CommonHeader,
    KeyValues,
    MessageBox,
    OpenStack,
    EC2,
    VMware,
    Kubernetes
  },

  data: () => ({

    MSG: MESSAGES,

    message: {
      show: false,
      text: "",
      title: ""
    },

    providerData : {},

    customProperties : [],
    serviceProperties: [],

    scripts: [],

    sharing : "private",

    valid : false,

    reservedKeysInPostCreateScripts : ["post_create_script", "key_name", "key_path", "size", "image", "platform", "vm_user", "vm_password"],

    testing : false,
    testResult : "unknown",
    testMessage : "",

    providerTechnologies : [
      {text:"OpenStack", value:"openstack"},
      {text:"VMWare", value:"vmware"},
      {text:"Amazon EC2", value:"ec2"},
      {text:"Kubernetes", value:"kubernetes"}
    ],

    nameRules: [
        v => !!v || 'A name is required',
        v => (v && v.length <= 50) || 'Name must be less than 50 characters',
        v => (v && v.trim().length > 0) || 'A name is required'
      ],

    descriptionRules: [
        v => !v || (v && v.length <= 200) || 'Description must be less than 200 characters',
      ]

  }),

  watch: {
    providerData: {
      deep: true,
      handler: function(val) {
        if(val.driver!="openstack") {
//          delete this.providerData.auth_version;
        }
      }
    },
    driver() {
      this.buildCustomProperties();
    }
  },

  computed: {
    driver() {
      return this.providerData.driver;
    }
  },

  mounted () {
    if(this.provider && this.provider.name) {
      this.providerData = this.provider;
      // make a deep copy of the provider
      this.originalData = JSON.parse(JSON.stringify(this.providerData));
      // if provider id is null (i.e. clone), empty secret fields
      if(!this.providerData.id) {
        for(var k in this.providerData) {
          if(k.startsWith("secret_")) {
            this.providerData[k] = "";
          }
        }
      }
      this.buildCustomProperties();
      this.buildServiceProperties();
      this.buildPostCreateScripts();
      this.sharing = getProviderSharingLevel(this.providerData);
    } else if(this.providerId) {
      this.$store.commit('fbkon')
      this.$http
            .get(this.$REST_BASE_URL + '/providers/'+this.providerId)
        .then(response => {
          this.providerData = response.data;
          // make a deep copy of the provider
          this.originalData = JSON.parse(JSON.stringify(this.providerData));
          this.buildCustomProperties();
          this.buildServiceProperties();
          this.buildPostCreateScripts();
          this.sharing = getProviderSharingLevel(this.providerData);
        }
      )
      .finally(() => {this.$store.commit('fbkoff')});
    } else if(this.templateProviderId) {
      this.$store.commit('fbkon')
      this.$http
            .get(this.$REST_BASE_URL + '/providers/'+this.templateProviderId)
        .then(response => {
          this.providerData = response.data;
          // make a deep copy of the provider
          this.originalData = JSON.parse(JSON.stringify(this.providerData));
          this.providerData.id=null;
          this.providerData.name='Copy of '+this.providerData.name;
          this.providerData.grants={owner:'me'}

          this.buildCustomProperties();
          this.buildServiceProperties();
          this.buildPostCreateScripts();
          this.sharing = getProviderSharingLevel(this.providerData);
        }
      )
      .finally(() => {this.$store.commit('fbkoff')});
    } else {
      this.providerData = Object.assign({}, this.providerData, { name: "New Provider" })
    }
  },

  methods:{

   reservedKeys: function() {
    return _getKnownProperties(this.providerData.driver);
   },

   isKnownProperty: function(key) {
    return _getKnownProperties(this.providerData.driver).includes(key)
   },

   isCustomProperty: function(key) {
    return !this.isKnownProperty(key);
   },

   buildCustomProperties: function() {
    this.customProperties.splice(0, this.customProperties.length)
    for(var k in this.providerData) {
      if(!_getKnownProperties(this.providerData.driver).includes(k)) {
        this.customProperties.push({"key":k, "value":this.providerData[k]});
      }
    }
   },

   buildServiceProperties: function() {
    this.serviceProperties.splice(0, this.serviceProperties.length)
    var props = ["vm_user", "vm_password"];
    for(var i in props) {
      var variants = this.providerData.service_properties[props[i]];
      if(variants) {
        for(var k in variants) {
          if(k=="default")
            this.serviceProperties.push({"key":props[i], "value":variants[k]});
          else
            this.serviceProperties.push({"key":props[i]+"_"+k, "value":variants[k]});
        }
      }
    }
   },

   buildPostCreateScripts: function() {
    // remove all previous scripts. Done this way instead of "arr = []" because we want to keep the same array instance
    this.scripts.splice(0, this.scripts.length)
    if(this.providerData.service_properties && this.providerData.service_properties.post_create_script && this.providerData.service_properties.post_create_script!="{}") {
      for(var k in this.providerData.service_properties.post_create_script) {
        this.scripts.push({key:k, value: this.providerData.service_properties.post_create_script[k]});
       }
     }
   },

   create: function(test, exit){
    this.$store.commit('fbkon')
    this.$http.post(this.$REST_BASE_URL + "/providers/", this.providerData)
    .then(response => {
        this.providerData = Object.assign({}, this.providerData, response.data)
        if(test)
          this.test();
        if(exit)
          this.exit();
      }
    )
    .catch(e => {console.log(e)})
    .finally(() => {this.$store.commit('fbkoff')});
   },

   _isArray: function(a) {
    return (!!a) && (a.constructor === Array);
   },

   _isObject: function(a) {
    return (!!a) && (a.constructor === Object);
   },

   _notSet: function(val) {
     return val==undefined || val==null;
   },

   // empty object or empty array
   _empty: function(val) {
     if(this._isObject(val))
       return Object.keys(val).length === 0;
     else if(this._isArray(val))
       return val.length;
     else
       return this._notSet(val);
   },

   _computeProviderDiff: function(original, modified) {
     var diff = {};

     // first look at new properties. Action: add new property with new value
     for(var k in modified) {
       var modVal = modified[k];
       var oldVal = original[k];
       if(this._notSet(oldVal) && !this._notSet(modVal)) {
         diff[k] = modVal;
       }
     }

     // then look at removed properties. Action: add property with null value
     for(k in original) {
       modVal = modified[k];
       oldVal = original[k];
       if(!this._notSet(oldVal) && this._notSet(modVal)) {
         diff[k] = null;
       }
     }

     // finally look at modified properties. Action: set the modified value. Work recursively.
     for(k in original) {
       modVal = modified[k];
       oldVal = original[k];
       if(!this._notSet(oldVal) && !this._notSet(modVal)) {
         if(this._isObject(oldVal) && this._isObject(modVal)) {
           var innerDiff = this._computeProviderDiff(oldVal, modVal);
           if(!this._empty(innerDiff)) {
             diff[k] = innerDiff;
           }
         } else if(this._isArray(oldVal) && this._isObject(modVal)) {
           console.log("WARNING - Unsupported diff: array vs object")
         } else if(this._isObject(oldVal) && this._isArray(modVal)) {
           console.log("WARNING - Unsupported diff: object vs array")
         } else if(this._isArray(oldVal) && this._isArray(modVal)) {
           console.log("WARNING - Unsupported diff: array vs array")
         } else {
           // primitive values
           if(modVal!=oldVal) {
             diff[k] = modVal;
           }
         }
       }
     }
     return diff;
   },

   _isKnownServicePropertyVariant: function(key) {
     var knownServiceProperties = ["vm_user", "vm_password"];
     for(var i in knownServiceProperties) {
       var ksp = knownServiceProperties[i];
       if(key.startsWith(ksp)) {
         return ksp;
       }
     }
     return null;
   },

   save: function(test, exit){

    // prepare a copy to be saved
    var uploadData = {};

    // copy known properties
    for(var k in this.providerData) {
      if(!this.isCustomProperty(k)) {
        uploadData[k] = this.providerData[k];
      }
    }

    // add custom properties
    for(var i in this.customProperties) {
      var prop = this.customProperties[i];
      if(this.isCustomProperty(prop.key)) {
        uploadData[prop.key] = prop.value;
      }
    }

    // add service properties
    uploadData["service_properties"] = {};
    for(i in this.serviceProperties) {
      prop = this.serviceProperties[i];
      var ksp = this._isKnownServicePropertyVariant(prop.key);
      if(ksp) {
        if(!uploadData["service_properties"][ksp]) {
          uploadData["service_properties"][ksp] = {};
        }
        var variantKey = prop.key.substring(ksp.length+1);
        if(variantKey=="") {
          variantKey="default";
        }
        uploadData["service_properties"][ksp][variantKey] = prop.value;
      }
    }

    // set grants
//    if(this.sharing=="private") {
//      uploadData.grants = {};
//    } else if(this.sharing=="public") {
//      uploadData.grants = {viewer:"org:public"};
//    } else {
//      uploadData.grants = {};
//    }

    // any secret property not changed is not uploaded
//    for(var k in uploadData) {
//      if(k.startsWith("secret_") && uploadData[k]=="********") {
//        delete uploadData[k]
//      }
//    }

    // add post create scripts
    uploadData.service_properties.post_create_script = {};
    for(var s in this.scripts) {
      var script = this.scripts[s];
      uploadData.service_properties.post_create_script[script.key] = script.value;
    }

    trimStringValues(uploadData);

    // set feedback ON
    this.$store.commit('fbkon')

    // create or update (depending on id)
    if(this.providerData.id==null) {
      this.$http.post(this.$REST_BASE_URL + "/providers", uploadData)
      .then((response) => {
          this.providerData.id = response.data.id;
          this.originalData = JSON.parse(JSON.stringify(this.providerData));
          if(test)
            this.test();
          if(exit)
            this.exit(this.providerData.id);
        }
      )
      .catch(error => {
        if (error.response) {
          if(error.response.status==401) {
            this.message.title="Not authorized";
            this.message.text="You are not allowed to create the provider.";
            this.message.show = true;
          }
        } else {
          console.log(error)
        }
      })
      .finally(() => {this.$store.commit('fbkoff')});
    } else {
      // build the diff
      var diff = this._computeProviderDiff(this.originalData, uploadData);

      this.$http.patch(this.$REST_BASE_URL + "/providers/"+this.providerData.id, diff)
        .then(() => {
          this.originalData = JSON.parse(JSON.stringify(this.providerData));
          if(test)
            this.test();
          if(exit)
            this.exit(this.providerData.id);
        }
      )
      .catch(error => {
        if (error.response) {
          if(error.response.status==401) {
            this.message.title="Not authorized";
            this.message.text="You are not allowed to update the provider.";
            this.message.show = true;
          }
        } else {
          console.log(error)
        }
      })
      .finally(() => {this.$store.commit('fbkoff')});
    }
   },

   exit: function(id) {
      id = id || this.providerId || this.templateProviderId;
      this.$emit("editingProviderComplete", {id:id})
   },

   test: function() {
      this.testing=true;
      this.testResult="";
      this.$http.get(this.$REST_BASE_URL + "/providers/"+this.providerData.id+"/check")
        .then(() => {
            this.testResult="success";
        }
      )
      .catch(e => {
        console.log(e);
        this.testResult="error"
      })
      .finally(() => {this.testing=false});
   }


 }

};

</script>

<style>

div.header {
  color:rgb(25,118,210);
  font-weight:bold;
}

div.subheader {
  font-size:90%;
  color:grey;
}

</style>
